Index: sys/rngtest.h
===================================================================
RCS file: sys/rngtest.h
diff -N sys/rngtest.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/rngtest.h	31 Oct 2011 04:29:31 -0000
@@ -0,0 +1,49 @@
+/*	$NetBSD: $ */
+
+/*-
+ * Copyright (c) 2011 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Thor Lancelot Simon.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+#ifndef _RNGTEST_H
+#define _RNGTEST_H
+
+#include <sys/types.h>
+
+#define FIPS140_RNG_TEST_BITS 20000
+#define FIPS140_RNG_TEST_BYTES (FIPS140_RNG_TEST_BITS / NBBY)
+
+typedef struct {
+	uint8_t rt_b[FIPS140_RNG_TEST_BYTES];
+	int	rt_poker[16];
+	int	rt_runs[2][7];
+	int	rt_nerrs;
+	char	rt_name[16];
+} rngtest_t;
+
+int rngtest(rngtest_t *const);
+
+#endif
Index: sys/sysctl.h
===================================================================
RCS file: /cvsroot/src/sys/sys/sysctl.h,v
retrieving revision 1.197
diff -u -b -r1.197 sysctl.h
--- sys/sysctl.h	21 Oct 2011 02:07:07 -0000	1.197
+++ sys/sysctl.h	31 Oct 2011 04:29:31 -0000
@@ -56,6 +56,10 @@
 #include <stdbool.h>
 #endif
 
+#ifdef _KERNEL
+#include <sys/cprng.h>
+#endif
+
 /*
  * Definitions for sysctl call.  The sysctl call uses a hierarchical name
  * for objects that can be examined or modified.  The name is expressed as
@@ -1208,6 +1212,8 @@
 
 extern const u_int sysctl_lwpflagmap[];
 
+extern cprng_strong_t *sysctl_prng;
+
 #else	/* !_KERNEL */
 #include <sys/cdefs.h>
 
Index: ufs/ffs/ffs_appleufs.c
===================================================================
RCS file: /cvsroot/src/sys/ufs/ffs/ffs_appleufs.c,v
retrieving revision 1.11
diff -u -b -r1.11 ffs_appleufs.c
--- ufs/ffs/ffs_appleufs.c	22 Jun 2011 04:01:33 -0000	1.11
+++ ufs/ffs/ffs_appleufs.c	31 Oct 2011 04:29:31 -0000
@@ -33,6 +33,7 @@
 #if defined(_KERNEL)
 #include <sys/kernel.h>
 #include <sys/systm.h>
+#include <sys/cprng.h>
 #endif
 
 #include <ufs/ufs/dinode.h>
@@ -136,9 +137,7 @@
 	}
 	if (uuid == 0) {
 #if defined(_KERNEL) && !defined(STANDALONE)
-		uuid = arc4random();
-		uuid <<= 32;
-		uuid |= arc4random();
+		uuid = cprng_fast64();
 #endif
 	}
 	namelen = strlen(name);
